#version 330 core

layout(location = 0)in vec3 inPosition;
layout(location = 2)in vec2 inTexCoord;
layout(location = 1)in vec3 inNormal;

uniform mat4 mvp;
uniform vec3 camera;

out vec2 texCoord;
out vec3 normal;

void main(void)
{
    texCoord = vec2(inTexCoord.x/2, inTexCoord.y);
    normal = inNormal.xyz;
    gl_Position = mvp * vec4(inPosition*camera.z, 1.0);
}
