#ifndef BEHAVIOR_H
#define BEHAVIOR_H

#include "coord.h"

#define DUDE_MEMORY_SIZE 128
#define LIBRARY_SIZE 128
#define COM_SIZE 32

class Map;

struct Com
{
    enum Flags {
        BOOK1 = 0,
        BOOK2 = 1,
        BOOK3 = 2,
        BOOK4 = 3,
        
        READ  = 0,
        WRITE = 4
    };

	int flag;
	char data[COM_SIZE];
};

struct Action
{
    enum Type {
        MOVE,
        ATTACK,
        PICK,
        PUT,
        WORK,
        WAIT,
        COMMUNICATE
    };
    
	Type type;
	Dir dir;
	Com com_data;
};

struct Info
{
    virtual bool getSuccess() = 0;
    virtual int getInventory() = 0;
    virtual const Com& getCom() = 0;
    virtual int getNear(Dir d) = 0;
    virtual int getInfo(Dir d) = 0;
};

/**
 * must be named "think"
 */
typedef void (*BehaviorFunction)(Action *action, char *memory, const Info *info);

#endif // BEHAVIOR_H
