#ifndef MAPSCENE_H
#define MAPSCENE_H

#include "map.h"
#include <scene.h>
#include <glm/vec2.hpp>
#include <glm/vec3.hpp>

struct MapScene : public Map, public BasicScene
{
public:
    struct Pix
    {
        glm::vec2 pos;
        glm::vec3 color;
        Pix(glm::vec2 p, glm::vec3 c) : pos(p), color(c) {}
    };

    MapScene(int n, int w, int h=0) : Map(n, w, h) {}

    ~MapScene();
    void changePixel(const Coord &c, glm::vec3 color);
    void changePixel(const Coord &c, Pixel::Type type);
    void initDraw();
    bool updateNecessary() { return !m_pixels.empty(); }
    void draw();

private:
    unsigned int m_vao;
    unsigned int m_vbo;

    std::vector<Pix> m_pixels;
};

#endif // MAPSCENE_H
